# -*- coding: utf-8 -*-

# Authors: Diego Sarmentero <diego.sarmentero@canonical.com>
#
# Copyright 2011 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Utils Functions Windows specific."""


import os
import subprocess
import sys

import win32api


def uninstall_application():
    """Uninstall Ubuntu One."""
    if hasattr(sys, "frozen"):
        exec_path = os.path.abspath(sys.executable)
    else:
        exec_path = os.path.dirname(__file__)
    folder = os.path.dirname(exec_path)
    uninstall_path = os.path.join(os.path.dirname(folder), "uninstall.exe")
    win32api.ShellExecute(None, 'runas',
        uninstall_path,
        '--mode qt', '', 0)


def start_control_panel():
    """Start the control panel."""
    # If we are in windows and "frozen", assume it's in
    # the same folder as this .exe
    if sys.platform == "win32" and hasattr(sys, "frozen"):
        cp_path = os.path.join(os.path.dirname(
            os.path.abspath(sys.executable)),
            "ubuntuone-control-panel-qt.exe")
    else:
        cp_path = "ubuntuone-control-panel-qt"
    subprocess.Popen([cp_path, ])
